blob: 9de9b97ff29d41760a26d931a94e5b95ab18c7cb [file] [log] [blame]
Wei Li73032c82023-03-15 18:31:38 +00001#!/bin/bash
2
3# Copyright (C) 2023 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17set -uo pipefail
18
19# Integration test for verifying generated SBOM for cuttlefish device.
20
21if [ ! -e "build/make/core/Makefile" ]; then
22 echo "$0 must be run from the top of the Android source tree."
23 exit 1
24fi
25
Wei Licd9948f2023-06-22 17:52:31 -070026function setup {
27 tmp_dir="$(mktemp -d tmp.XXXXXX)"
28 trap 'cleanup "${tmp_dir}"' EXIT
29 echo "${tmp_dir}"
30}
31
Wei Li73032c82023-03-15 18:31:38 +000032function cleanup {
Wei Licd9948f2023-06-22 17:52:31 -070033 tmp_dir="$1"; shift
Wei Li73032c82023-03-15 18:31:38 +000034 rm -rf "${tmp_dir}"
35}
Wei Li8a8d5a92023-03-29 13:41:34 -070036
37function run_soong {
Wei Licd9948f2023-06-22 17:52:31 -070038 target_product="$1";shift
39 out_dir="$1"; shift
40 targets="$1"; shift
41 if [ "$#" -ge 1 ]; then
42 apps=$1; shift
43 TARGET_PRODUCT="${target_product}" TARGET_BUILD_VARIANT=userdebug OUT_DIR="${out_dir}" TARGET_BUILD_UNBUNDLED=true TARGET_BUILD_APPS=$apps build/soong/soong_ui.bash --make-mode ${targets}
44 else
45 TARGET_PRODUCT="${target_product}" TARGET_BUILD_VARIANT=userdebug OUT_DIR="${out_dir}" build/soong/soong_ui.bash --make-mode ${targets}
46 fi
Wei Li8a8d5a92023-03-29 13:41:34 -070047}
48
Wei Li7c1e7f02023-03-29 17:43:35 -070049function diff_files {
Wei Licd9948f2023-06-22 17:52:31 -070050 file_list_file="$1"; shift
51 files_in_spdx_file="$1"; shift
52 partition_name="$1"; shift
53 exclude=
54 if [ -v 'diff_excludes[$partition_name]' ]; then
55 exclude=${diff_excludes[$partition_name]}
Wei Li8a8d5a92023-03-29 13:41:34 -070056 fi
Wei Li8a8d5a92023-03-29 13:41:34 -070057
Wei Licd9948f2023-06-22 17:52:31 -070058 diff "$file_list_file" "$files_in_spdx_file" $exclude
59 if [ $? != "0" ]; then
60 echo Found diffs in $f and SBOM.
61 exit 1
62 else
63 echo No diffs.
64 fi
65}
Wei Li8a8d5a92023-03-29 13:41:34 -070066
Wei Licd9948f2023-06-22 17:52:31 -070067function test_sbom_aosp_cf_x86_64_phone {
68 # Setup
69 out_dir="$(setup)"
Wei Li8a8d5a92023-03-29 13:41:34 -070070
Wei Licd9948f2023-06-22 17:52:31 -070071 # Test
72 # m droid, build sbom later in case additional dependencies might be built and included in partition images.
73 run_soong "aosp_cf_x86_64_phone" "${out_dir}" "droid dump.erofs lz4"
Wei Li8a8d5a92023-03-29 13:41:34 -070074
Wei Licd9948f2023-06-22 17:52:31 -070075 product_out=$out_dir/target/product/vsoc_x86_64
76 sbom_test=$product_out/sbom_test
77 mkdir -p $sbom_test
78 cp $product_out/*.img $sbom_test
79
80 # m sbom
81 run_soong "aosp_cf_x86_64_phone" "${out_dir}" sbom
82
83 # Generate installed file list from .img files in PRODUCT_OUT
84 dump_erofs=$out_dir/host/linux-x86/bin/dump.erofs
85 lz4=$out_dir/host/linux-x86/bin/lz4
86
87 declare -A diff_excludes
Wei Li6c550d42023-08-31 21:50:42 -070088 diff_excludes[system]="-I /system/bin/hwservicemanager"
Wei Licd9948f2023-06-22 17:52:31 -070089
90 # Example output of dump.erofs is as below, and the data used in the test start
91 # at line 11. Column 1 is inode id, column 2 is inode type and column 3 is name.
92 # Each line is captured in variable "entry", awk is used to get type and name.
93 # Output of dump.erofs:
94 # File : /
95 # Size: 160 On-disk size: 160 directory
96 # NID: 39 Links: 10 Layout: 2 Compression ratio: 100.00%
97 # Inode size: 64 Extent size: 0 Xattr size: 16
98 # Uid: 0 Gid: 0 Access: 0755/rwxr-xr-x
99 # Timestamp: 2023-02-14 01:15:54.000000000
100 #
101 # NID TYPE FILENAME
102 # 39 2 .
103 # 39 2 ..
104 # 47 2 app
105 # 1286748 2 bin
106 # 1286754 2 etc
107 # 5304814 2 lib
108 # 5309056 2 lib64
109 # 5309130 2 media
110 # 5388910 2 overlay
111 # 5479537 2 priv-app
112 EROFS_IMAGES="\
113 $sbom_test/product.img \
114 $sbom_test/system.img \
115 $sbom_test/system_ext.img \
116 $sbom_test/system_dlkm.img \
117 $sbom_test/system_other.img \
118 $sbom_test/odm.img \
119 $sbom_test/odm_dlkm.img \
120 $sbom_test/vendor.img \
121 $sbom_test/vendor_dlkm.img"
122 for f in $EROFS_IMAGES; do
123 partition_name=$(basename $f | cut -d. -f1)
124 file_list_file="${sbom_test}/sbom-${partition_name}-files.txt"
125 files_in_spdx_file="${sbom_test}/sbom-${partition_name}-files-in-spdx.txt"
126 rm "$file_list_file" > /dev/null 2>&1 || true
127 all_dirs="/"
128 while [ ! -z "$all_dirs" ]; do
129 dir=$(echo "$all_dirs" | cut -d ' ' -f1)
130 all_dirs=$(echo "$all_dirs" | cut -d ' ' -f1 --complement -s)
131 entries=$($dump_erofs --ls --path "$dir" $f | tail -n +11)
132 while read -r entry; do
133 inode_type=$(echo $entry | awk -F ' ' '{print $2}')
134 name=$(echo $entry | awk -F ' ' '{print $3}')
135 case $inode_type in
136 "2") # directory
137 all_dirs=$(echo "$all_dirs $dir/$name" | sed 's/^\s*//')
138 ;;
139 "1"|"7") # 1: file, 7: symlink
140 (
141 if [ "$partition_name" != "system" ]; then
142 # system partition is mounted to /, not to prepend partition name.
143 printf %s "/$partition_name"
144 fi
145 echo "$dir/$name" | sed 's#^//#/#'
146 ) >> "$file_list_file"
147 ;;
148 esac
149 done <<< "$entries"
150 done
151 sort -n -o "$file_list_file" "$file_list_file"
152
153 grep "FileName: /${partition_name}/" $product_out/sbom.spdx | sed 's/^FileName: //' > "$files_in_spdx_file"
154 if [ "$partition_name" = "system" ]; then
155 # system partition is mounted to /, so include FileName starts with /root/ too.
156 grep "FileName: /root/" $product_out/sbom.spdx | sed 's/^FileName: \/root//' >> "$files_in_spdx_file"
157 fi
158 sort -n -o "$files_in_spdx_file" "$files_in_spdx_file"
159
160 echo ============ Diffing files in $f and SBOM
161 diff_files "$file_list_file" "$files_in_spdx_file" "$partition_name"
162 done
163
164 RAMDISK_IMAGES="$product_out/ramdisk.img"
165 for f in $RAMDISK_IMAGES; do
166 partition_name=$(basename $f | cut -d. -f1)
167 file_list_file="${sbom_test}/sbom-${partition_name}-files.txt"
168 files_in_spdx_file="${sbom_test}/sbom-${partition_name}-files-in-spdx.txt"
169 # lz4 decompress $f to stdout
170 # cpio list all entries like ls -l
171 # grep filter normal files and symlinks
172 # awk get entry names
173 # sed remove partition name from entry names
174 $lz4 -c -d $f | cpio -tv 2>/dev/null | grep '^[-l]' | awk -F ' ' '{print $9}' | sed "s:^:/$partition_name/:" | sort -n > "$file_list_file"
175
176 grep "FileName: /${partition_name}/" $product_out/sbom.spdx | sed 's/^FileName: //' | sort -n > "$files_in_spdx_file"
177
178 echo ============ Diffing files in $f and SBOM
179 diff_files "$file_list_file" "$files_in_spdx_file" "$partition_name"
180 done
181
Wei Li8ea2ffc2023-08-01 15:20:38 -0700182 verify_package_verification_code "$product_out/sbom.spdx"
183
Wei Licd9948f2023-06-22 17:52:31 -0700184 # Teardown
185 cleanup "${out_dir}"
186}
187
Wei Li8ea2ffc2023-08-01 15:20:38 -0700188function verify_package_verification_code {
189 local sbom_file="$1"; shift
190
191 local -a file_checksums
192 local package_product_found=
193 while read -r line;
194 do
195 if grep -q 'PackageVerificationCode' <<<"$line"
196 then
197 package_product_found=true
198 fi
199 if [ -n "$package_product_found" ]
200 then
201 if grep -q 'FileChecksum' <<< "$line"
202 then
203 checksum=$(echo $line | sed 's/^.*: //')
204 file_checksums+=("$checksum")
205 fi
206 fi
207 done <<< "$(grep -E 'PackageVerificationCode|FileChecksum' $sbom_file)"
208 IFS=$'\n' file_checksums=($(sort <<<"${file_checksums[*]}")); unset IFS
209 IFS= expected_package_verification_code=$(printf "${file_checksums[*]}" | sha1sum | sed 's/[[:space:]]*-//'); unset IFS
210
211 actual_package_verification_code=$(grep PackageVerificationCode $sbom_file | sed 's/PackageVerificationCode: //g')
212 if [ $actual_package_verification_code = $expected_package_verification_code ]
213 then
214 echo "Package verification code is correct."
215 else
216 echo "Unexpected package verification code."
217 exit 1
218 fi
219}
220
Wei Li59df0ee2023-07-10 15:50:38 -0700221function test_sbom_unbundled_apex {
222 # Setup
223 out_dir="$(setup)"
224
225 # run_soong to build com.android.adbd.apex
226 run_soong "module_arm64" "${out_dir}" "sbom deapexer" "com.android.adbd"
227
228 deapexer=${out_dir}/host/linux-x86/bin/deapexer
229 debugfs=${out_dir}/host/linux-x86/bin/debugfs_static
230 apex_file=${out_dir}/target/product/module_arm64/system/apex/com.android.adbd.apex
231 echo "============ Diffing files in $apex_file and SBOM"
232 set +e
233 # deapexer prints the list of all files and directories
234 # sed extracts the file/directory names
235 # grep removes directories
236 # sed removes leading ./ in file names
237 diff -I /system/apex/com.android.adbd.apex -I apex_manifest.pb \
238 <($deapexer --debugfs_path=$debugfs list --extents ${apex_file} | sed -E 's#(.*) \[.*\]$#\1#' | grep -v "/$" | sed -E 's#^\./(.*)#\1#' | sort -n) \
239 <(grep '"fileName": ' ${apex_file}.spdx.json | sed -E 's/.*"fileName": "(.*)",/\1/' | sort -n )
240
241 if [ $? != "0" ]; then
242 echo "Diffs found in $apex_file and SBOM"
243 exit 1
244 else
245 echo "No diffs."
246 fi
247 set -e
248
249 # Teardown
250 cleanup "${out_dir}"
251}
252
253function test_sbom_unbundled_apk {
254 # Setup
255 out_dir="$(setup)"
256
257 # run_soong to build Browser2.apk
258 run_soong "module_arm64" "${out_dir}" "sbom" "Browser2"
259
260 sbom_file=${out_dir}/target/product/module_arm64/system/product/app/Browser2/Browser2.apk.spdx.json
261 echo "============ Diffing files in Browser2.apk and SBOM"
262 set +e
263 # There is only one file in SBOM of APKs
264 diff \
265 <(echo "/system/product/app/Browser2/Browser2.apk" ) \
266 <(grep '"fileName": ' ${sbom_file} | sed -E 's/.*"fileName": "(.*)",/\1/' )
267
268 if [ $? != "0" ]; then
269 echo "Diffs found in $sbom_file"
270 exit 1
271 else
272 echo "No diffs."
273 fi
274 set -e
275
276 # Teardown
277 cleanup "${out_dir}"
278}
279
280test_sbom_aosp_cf_x86_64_phone
281test_sbom_unbundled_apex
282test_sbom_unbundled_apk